#!/bin/sh

# FPGA Configuration filename, if the configuration file has a different filename change this variable
FILE1=fpga.sof
# Filename of the executable, if the executable has a different filename change this variable
FILE2=ADIEvalBoard.elf

if [ -f $FILE1 ];
then
    nios2-configure-sof fpga.sof
else
    echo "ERROR : fpga.sof does not exist!"
    exit
fi

echo "FPGA configuration done ..."

 Program the FPGA with the selected software
if [ -f $FILE2 ];
then
    nios2-download -g ADIEvalBoard.elf
else
    echo "ERROR : ADIEvalBoard.elf does not exist!"
    exit
fi

#echo "Software was downloaded to FPGA ..."

# Verify is the device was set up correctly
jtagconfig -n

# Start the nios2-terminal
nios2-terminal
